Index: trunk/Assembly_Library/Inc/Debug.inc
===================================================================
--- trunk/Assembly_Library/Inc/Debug.inc	(revision 589)
+++ trunk/Assembly_Library/Inc/Debug.inc	(revision 590)
@@ -22,6 +22,6 @@
 
 	mov		ax, %1
-	mov		bx, %2
-	CALL_DISPLAY_LIBRARY PrintWordFromAXwithBaseInBX
+	mov		bl, %2
+	CALL_DISPLAY_LIBRARY PrintWordFromAXWithBaseInBL
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 	call	Keyboard_RemoveAllKeystrokesFromBuffer
Index: trunk/Assembly_Library/Inc/Display.inc
===================================================================
--- trunk/Assembly_Library/Inc/Display.inc	(revision 589)
+++ trunk/Assembly_Library/Inc/Display.inc	(revision 590)
@@ -82,7 +82,7 @@
 	.FormatNullTerminatedStringFromCSSI				resb	2
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-	.PrintSignedWordFromAXWithBaseInBX				resb	2
-%endif
-	.PrintWordFromAXwithBaseInBX					resb	2
+	.PrintSignedWordFromAXWithBaseInBL				resb	2
+%endif
+	.PrintWordFromAXWithBaseInBL					resb	2
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
 	.PrintQWordFromSSBPwithBaseInBX					resb	2
Index: trunk/Assembly_Library/Src/Display/Display.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/Display.asm	(revision 589)
+++ trunk/Assembly_Library/Src/Display/Display.asm	(revision 590)
@@ -97,7 +97,7 @@
 	%define FormatNullTerminatedStringFromCSSI				Display_FormatNullTerminatedStringFromCSSI
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
-	%define PrintSignedWordFromAXWithBaseInBX				DisplayPrint_SignedWordFromAXWithBaseInBX
+	%define PrintSignedWordFromAXWithBaseInBL				DisplayPrint_SignedWordFromAXWithBaseInBL
 %endif
-	%define PrintWordFromAXwithBaseInBX						DisplayPrint_WordFromAXWithBaseInBX
+	%define PrintWordFromAXWithBaseInBL						DisplayPrint_WordFromAXWithBaseInBL
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS OR EXCLUDE_FROM_XTIDECFG
 	%define PrintQWordFromSSBPwithBaseInBX					DisplayPrint_QWordFromSSBPwithBaseInBX
Index: trunk/Assembly_Library/Src/Display/DisplayFormat.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 589)
+++ trunk/Assembly_Library/Src/Display/DisplayFormat.asm	(revision 590)
@@ -334,6 +334,6 @@
 d_FormatSignedDecimalWord:
 	mov		ax, [bp]
-	mov		bx, 10
-	jmp		DisplayPrint_SignedWordFromAXWithBaseInBX
+	mov		bl, 10
+	jmp		DisplayPrint_SignedWordFromAXWithBaseInBL
 %endif
 
@@ -341,12 +341,12 @@
 u_FormatUnsignedDecimalWord:
 	mov		ax, [bp]
-	mov		bx, 10
-	jmp		DisplayPrint_WordFromAXWithBaseInBX
+	mov		bl, 10
+	jmp		DisplayPrint_WordFromAXWithBaseInBL
 
 ALIGN DISPLAY_JUMP_ALIGN
 x_FormatHexadecimalWord:
 	mov		ax, [bp]
-	mov		bx, 16
-	call	DisplayPrint_WordFromAXWithBaseInBX
+	mov		bl, 16
+	call	DisplayPrint_WordFromAXWithBaseInBL
 	mov		al, 'h'
 	jmp		DisplayPrint_CharacterFromAL
@@ -354,8 +354,7 @@
 ALIGN DISPLAY_JUMP_ALIGN
 I_FormatDashForZero:
-	mov		ax, [bp]
-	test	ax,ax
-	jnz		u_FormatUnsignedDecimalWord
-	mov		[bp], word g_szDashForZero
+	cmp		WORD [bp], 0
+	jne		SHORT u_FormatUnsignedDecimalWord
+	mov		WORD [bp], g_szDashForZero
 ;;; fall-through
 
@@ -366,5 +365,5 @@
 	mov		si, [bp]
 
-	cmp		si, byte 07fh		;  well within the boundaries of ROMVARS_size
+	cmp		si, BYTE 7Fh		; well within the boundaries of ROMVARS_size
 	jb		.notFormatted
 
Index: trunk/Assembly_Library/Src/Display/DisplayPrint.asm
===================================================================
--- trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 589)
+++ trunk/Assembly_Library/Src/Display/DisplayPrint.asm	(revision 590)
@@ -83,20 +83,20 @@
 
 ;--------------------------------------------------------------------
-; DisplayPrint_SignedWordFromAXWithBaseInBX
+; DisplayPrint_SignedWordFromAXWithBaseInBL
 ;	Parameters:
 ;		AX:		Word to display
-;		BX:		Integer base (binary=2, octal=8, decimal=10, hexadecimal=16)
-;		DS:		BDA segment (zero)
-;		ES:DI:	Ptr to cursor location in video RAM
-;	Returns:
-;		DI:		Updated offset to video RAM
-;	Corrupts registers:
-;		AX, DX
+;		BL:		Integer base (binary=2, octal=8, decimal=10, hexadecimal=16)
+;		DS:		BDA segment (zero)
+;		ES:DI:	Ptr to cursor location in video RAM
+;	Returns:
+;		DI:		Updated offset to video RAM
+;	Corrupts registers:
+;		AX, BH, DX
 ;--------------------------------------------------------------------
 %ifndef EXCLUDE_FROM_XTIDE_UNIVERSAL_BIOS
 ALIGN DISPLAY_JUMP_ALIGN
-DisplayPrint_SignedWordFromAXWithBaseInBX:
-	test	ax, ax
-	jns		SHORT DisplayPrint_WordFromAXWithBaseInBX
+DisplayPrint_SignedWordFromAXWithBaseInBL:
+	sahf
+	jns		SHORT DisplayPrint_WordFromAXWithBaseInBL
 
 	push	ax
@@ -105,26 +105,27 @@
 	pop		ax
 	neg		ax
-	; Fall to DisplayPrint_WordFromAXWithBaseInBX
-%endif
-
-
-;--------------------------------------------------------------------
-; DisplayPrint_WordFromAXWithBaseInBX
+	; Fall to DisplayPrint_WordFromAXWithBaseInBL
+%endif
+
+
+;--------------------------------------------------------------------
+; DisplayPrint_WordFromAXWithBaseInBL
 ;	Parameters:
 ;		AX:		Word to display
-;		BX:		Integer base (binary=2, octal=8, decimal=10, hexadecimal=16)
-;		DS:		BDA segment (zero)
-;		ES:DI:	Ptr to cursor location in video RAM
-;	Returns:
-;		DI:		Updated offset to video RAM
-;	Corrupts registers:
-;		AX, DX
+;		BL:		Integer base (binary=2, octal=8, decimal=10, hexadecimal=16)
+;		DS:		BDA segment (zero)
+;		ES:DI:	Ptr to cursor location in video RAM
+;	Returns:
+;		DI:		Updated offset to video RAM
+;	Corrupts registers:
+;		AX, BH, DX
 ;--------------------------------------------------------------------
 %ifndef MODULE_STRINGS_COMPRESSED
 ALIGN DISPLAY_JUMP_ALIGN
-DisplayPrint_WordFromAXWithBaseInBX:
+DisplayPrint_WordFromAXWithBaseInBL:
 	push	cx
 
 	xor		cx, cx
+	xor		bh, bh				; Base now in BX
 ALIGN DISPLAY_JUMP_ALIGN
 .DivideLoop:
Index: trunk/Assembly_Library/Src/LibraryTests.asm
===================================================================
--- trunk/Assembly_Library/Src/LibraryTests.asm	(revision 589)
+++ trunk/Assembly_Library/Src/LibraryTests.asm	(revision 590)
@@ -598,8 +598,8 @@
 	pop		ds
 	mov		si, .rgwItems
-	mov		bx, 16
+	mov		bl, 16
 .Loop:
 	lodsw
-	CALL_DISPLAY_LIBRARY PrintSignedWordFromAXWithBaseInBX
+	CALL_DISPLAY_LIBRARY PrintSignedWordFromAXWithBaseInBL
 	CALL_DISPLAY_LIBRARY PrintNewlineCharacters
 	loop	.Loop
Index: trunk/BIOS_Drive_Information_Tool/Src/Main.asm
===================================================================
--- trunk/BIOS_Drive_Information_Tool/Src/Main.asm	(revision 589)
+++ trunk/BIOS_Drive_Information_Tool/Src/Main.asm	(revision 590)
@@ -28,5 +28,5 @@
 %include "EBIOS.inc"			; From XTIDE Universal BIOS
 %include "IdeRegisters.inc"		; From XTIDE Universal BIOS
-%include "Romvars.inc"			; From XTIDE Universal BIOS
+%include "RomVars.inc"			; From XTIDE Universal BIOS
 %include "CustomDPT.inc"		; From XTIDE Universal BIOS
 
Index: trunk/BIOS_Drive_Information_Tool/Src/Strings.asm
===================================================================
--- trunk/BIOS_Drive_Information_Tool/Src/Strings.asm	(revision 589)
+++ trunk/BIOS_Drive_Information_Tool/Src/Strings.asm	(revision 590)
@@ -22,7 +22,7 @@
 
 g_szProgramName:	db	"BIOS Drive Information Tool v1.0.2",CR,LF
-					db	"(C) 2012-2013 by XTIDE Universal BIOS Team",CR,LF
+					db	"(C) 2012-2016 by XTIDE Universal BIOS Team",CR,LF
 					db	"Released under GNU GPL v2",CR,LF
-					db	"http://code.google.com/p/xtideuniversalbios/",CR,LF,NULL
+					db	"http://xtideuniversalbios.org/",CR,LF,NULL
 
 g_szPressAnyKey:	db	CR,LF,"Press any key to display next drive.",CR,LF,NULL
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuitemPrint.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuitemPrint.asm	(revision 589)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/MenuitemPrint.asm	(revision 590)
@@ -248,6 +248,6 @@
 
 	call	Menuitem_GetValueToAXfromMenuitemInDSSI
-	mov		bx, 10
-	CALL_DISPLAY_LIBRARY PrintWordFromAXwithBaseInBX
+	mov		bl, 10
+	CALL_DISPLAY_LIBRARY PrintWordFromAXWithBaseInBL
 	jmp		SHORT MenuitemPrint_FinishPrintingUnsignedOrHexValue
 
@@ -270,6 +270,6 @@
 
 	call	Menuitem_GetValueToAXfromMenuitemInDSSI
-	mov		bx, 16
-	CALL_DISPLAY_LIBRARY PrintWordFromAXwithBaseInBX
+	mov		bl, 16
+	CALL_DISPLAY_LIBRARY PrintWordFromAXWithBaseInBL
 	mov		al, 'h'
 	CALL_DISPLAY_LIBRARY PrintCharacterFromAL
Index: trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 589)
+++ trunk/XTIDE_Universal_BIOS_Configurator_v2/Src/Strings.asm	(revision 590)
@@ -92,13 +92,13 @@
 g_szNfoMainFlash:		db	"Flash loaded BIOS image to EEPROM.",NULL
 g_szNfoMainSave:		db	"Save BIOS changes back to original file from which it was loaded.",NULL
-g_szNfoMainLicense:		db	"XTIDE Universal BIOS and XTIDECFG Copyright (C) 2009-2010 by Tomi Tilli, 2011-2013 by XTIDE Universal BIOS Team."
+g_szNfoMainLicense:		db	"XTIDE Universal BIOS and XTIDECFG Copyright (C) 2009-2010 by Tomi Tilli, 2011-2016 by XTIDE Universal BIOS Team."
 						db	" Released under GNU GPL v2, with ABSOLUTELY NO WARRANTY. Press ENTER for more details...",NULL
-g_szNfoMainHomePage:	db	"Visit http://code.google.com/p/ xtideuniversalbios (home page) and http://vintage-computer.com/ vcforum (support)",NULL
+g_szNfoMainHomePage:	db	"Visit http://xtideuniversalbios.org (home page) and http://vcfed.org/forum (support)",NULL
 
 g_szHelpMainLicense:	db	"XTIDE Universal BIOS and XTIDECFG Configuration program are Copyright 2009-2010 by Tomi Tilli,"
-						db	" 2011-2013 by XTIDE Universal BIOS Team. Released under GNU GPL v2. This software comes with ABSOLUTELY NO WARRANTY."
+						db	" 2011-2016 by XTIDE Universal BIOS Team. Released under GNU GPL v2. This software comes with ABSOLUTELY NO WARRANTY."
 						db	" This is free software, and you are welcome to redistribute it under certain conditions."
 						db	" See the LICENSE.TXT file that was included with this distribution,"
-						db	" visit http://www.gnu.org/licenses/ gpl-2.0.html, or visit http://code.coogle.com/p/ xtideuniversalbios.",NULL
+						db	" visit http://www.gnu.org/licenses/ gpl-2.0.html, or visit http://xtideuniversalbios.org.",NULL
 
 ; Strings for XTIDE Universal BIOS configuration menu